services:
  db:
    # Version that matches the version Ubuntu is using, so we can pg_dump the DB as needed.
    # Production can be much newer.
    image: postgres:14-alpine
    environment:
      - POSTGRES_PASSWORD=postgres
    ports:
      - "5432:5432"

  redis:
    container_name: "listaflow-redis"
    hostname: listaflow-redis
    image: redis:7.0.0-alpine
    command: redis-server --requirepass password

  django: &django
    image: listaflow_django
    build:
      context: .
      dockerfile: docker/backend/Dockerfile
    depends_on:
      - db
      - redis
    command: python manage.py runserver 0.0.0.0:8000
    stdin_open: true
    tty: true
    ports:
      - "8000:8000"
    volumes:
      - ./:/home/app/listaflow
    environment:
      - DATABASE_NAME=postgres
      - DATABASE_USER=postgres
      - DATABASE_PASSWORD=postgres
      - DATABASE_HOST=db
      - DATABASE_PORT=5432
      - REDIS_URL=redis://:password@redis
      - STATIC_ROOT=/home/app/static
      - MEDIA_ROOT=/home/app/media
      - CELERY_TIMEZONE=UTC
      - CELERY_BROKER_TRANSPORT=redis
      - CELERY_BROKER_USER=
      - CELERY_BROKER_HOSTNAME=listaflow-redis:6379
      - CELERY_BROKER_VHOST=0
      - CELERY_BROKER_PASSWORD=password
      - FRONTEND_URL=http://localhost:3000
      - DJANGO_READ_DOT_ENV_FILE=True

  celeryworker:
    <<: *django
    profiles: ["celery"]
    command: celery -A conf.celery_app worker -l debug
    volumes:
      - ./:/home/app/listaflow
    depends_on:
      - redis
      - db
      - celerybeat
    ports: []

  celerybeat:
    <<: *django
    profiles: ["celery"]
    command: celery -A conf.celery_app beat -l debug
    volumes:
      - ./:/home/app/listaflow
    depends_on:
      - redis
      - django
    ports: []

  flower:
    <<: *django
    ports:
      - "5555:5555"
    command: celery -A conf.celery_app flower -l debug

  frontend:
    profiles: ["frontend"]
    command: npm --prefix /app/frontend run start
    image: node:20.16-alpine
    env_file:
      - path: "frontend/.env.local"
        required: false
    ports:
      - "3000:3000"
    volumes:
      - ./:/app/
